> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.getunleash.io/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.getunleash.io/_mcp/server.

# [BETA] List action sets.

GET https://app.unleash-instance.example.com/api/admin/projects/{projectId}/actions

**Enterprise feature**

**[BETA]** This API is in beta state, which means it may change or be removed in the future.

Returns the list of all action sets.

Reference: https://docs.getunleash.io/api/get-actions

## Authentication

- `Authorization` header (required) — API key needed to access this API
- `Authorization` header (bearer token, required) — API key needed to access this API, in Bearer token format

## Request

### Path parameters

- `projectId` (string, required)

## Response

### 200

actionsListSchema

- `actions` (list of object, required) — A list of action sets.
  - `id` (integer, required) — The ID of the action set.
  - `project` (string, required) — The project that this action set belongs to.
  - `createdAt` (string, required) — The date and time of when the action set was created.
  - `createdByUserId` (integer, required) — The ID of the user that created this action set.
  - `name` (string, required) — The name of the action set
  - `actorId` (integer, required) — The id of the service account that will execute the action
  - `actions` (list of object, required) — The list of actions to execute in sequential order when the action set is triggered.
    - `id` (integer, required) — The id of the action set
    - `createdAt` (string, required) — The date and time of when the action was created.
    - `createdByUserId` (integer, required) — The id of user that created this action set
    - `action` (string, required) — The name of the action to execute
    - `sortOrder` (integer, required) — The order in which the action should be executed
    - `executionParams` (map from string to any, optional, default: {}) — A map of parameters to pass to the action
  - `match` (object, required) — Defines a matching rule for the signal that will trigger the action set
    - `source` (enum, required) — Match the source of the signal
      - Allowed values: `signal-endpoint`
    - `sourceId` (double, required) — Match the source id of the signal
    - `payload` (map from string to any, required) — Match the payload of the signal
  - `description` (string, optional, nullable) — The description of the action set
  - `enabled` (boolean, optional, default: true) — Whether this action set is enabled or not

## Errors

### 401 Unauthorized Error

Authorization information is missing or invalid. Provide a valid API token as the `authorization` header, e.g. `authorization:*.*.my-admin-token`.

- `id` (string, optional) — The ID of the error instance
- `name` (string, optional) — The name of the error kind
- `message` (string, optional) — A description of what went wrong.

### 403 Forbidden Error

The provided user credentials are valid, but the user does not have the necessary permissions to perform this operation

- `id` (string, optional) — The ID of the error instance
- `name` (string, optional) — The name of the error kind
- `message` (string, optional) — A description of what went wrong.

## Examples

**Response**

```json
{
  "actions": [
    {
      "id": 1,
      "project": "default",
      "createdAt": "2023-12-27T13:37:00+01:00",
      "createdByUserId": 1,
      "name": "Disable new features",
      "actorId": 12,
      "actions": [
        {
          "id": 1,
          "createdAt": "2023-12-27T13:37:00+01:00",
          "createdByUserId": 1,
          "action": "disable-feature",
          "sortOrder": 1,
          "executionParams": {
            "featureName": "my-feature"
          }
        }
      ],
      "match": {
        "source": "signal-endpoint",
        "sourceId": 123,
        "payload": {
          "type": "error-rate-above-threshold"
        }
      },
      "description": "Disables new features when error rate is above threshold",
      "enabled": true
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://app.unleash-instance.example.com/api/admin/projects/projectId/actions"

headers = {"Authorization": "<apiKey>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://app.unleash-instance.example.com/api/admin/projects/projectId/actions';
const options = {method: 'GET', headers: {Authorization: '<apiKey>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://app.unleash-instance.example.com/api/admin/projects/projectId/actions"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "<apiKey>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://app.unleash-instance.example.com/api/admin/projects/projectId/actions")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = '<apiKey>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://app.unleash-instance.example.com/api/admin/projects/projectId/actions")
  .header("Authorization", "<apiKey>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://app.unleash-instance.example.com/api/admin/projects/projectId/actions', [
  'headers' => [
    'Authorization' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://app.unleash-instance.example.com/api/admin/projects/projectId/actions");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "<apiKey>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "<apiKey>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://app.unleash-instance.example.com/api/admin/projects/projectId/actions")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```